package com.terraformersmc.terraform.block;

import net.minecraft.block.*;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1304;
import net.minecraft.class_1657;
import net.minecraft.class_1766;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1821;
import net.minecraft.class_1937;
import net.minecraft.class_1944;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2372;
import net.minecraft.class_2488;
import net.minecraft.class_2680;
import net.minecraft.class_3218;
import net.minecraft.class_3417;
import net.minecraft.class_3419;
import net.minecraft.class_3486;
import net.minecraft.class_3558;
import net.minecraft.class_3965;
import net.minecraft.class_4538;
import java.util.Random;
import java.util.function.Supplier;

/**
 * A custom grass block that allows one to define their own soil types, used for things like basalt grass.
 */
public class TerraformGrassBlock extends class_2372 {
	private class_2248 dirt;
	private Supplier<class_2248> path;

	public TerraformGrassBlock(class_2248 dirt, Supplier<class_2248> path, class_2248.class_2251 settings) {
		super(settings);

		this.dirt = dirt;
		this.path = path;
	}

	private static boolean canSurvive(class_2680 state, class_4538 world, class_2338 pos) {
		class_2338 above = pos.method_10084();
		class_2680 aboveState = world.method_8320(above);

		if (aboveState.method_11614() == class_2246.field_10477 && aboveState.method_11654(class_2488.field_11518) == 1) {
			return true;
		} else {
			int lightingAt = class_3558.method_20049(world, state, pos, aboveState, above, class_2350.field_11036, aboveState.method_11581(world, above));
			return lightingAt < world.method_8315();
		}
	}

	private static boolean canSpread(class_2680 state, class_4538 world, class_2338 pos) {
		class_2338 above = pos.method_10084();
		return canSurvive(state, world, pos) && !world.method_8316(above).method_15767(class_3486.field_15517);
	}

	@Override
	public void method_9588(class_2680 state, class_3218 world, class_2338 pos, Random random) {
		if (!world.field_9236) {
			if (!canSurvive(state, world, pos)) {
				world.method_8501(pos, dirt.method_9564());
			} else if (world.method_8314(class_1944.field_9284, pos.method_10084()) >= 4) {
				if (world.method_8314(class_1944.field_9284, pos.method_10084()) >= 9) {
					class_2680 defaultState = this.method_9564();

					for (int int_1 = 0; int_1 < 4; ++int_1) {
						class_2338 blockPos_2 = pos.method_10069(random.nextInt(3) - 1, random.nextInt(5) - 3, random.nextInt(3) - 1);

						if (world.method_8320(blockPos_2).method_11614() == dirt && canSpread(defaultState, world, blockPos_2)) {
							world.method_8501(blockPos_2, defaultState.method_11657(field_11522, world.method_8320(blockPos_2.method_10084()).method_11614() == class_2246.field_10477));
						}
					}
				}

			}
		}
	}

	@Override
	@SuppressWarnings("deprecation")
	public class_1269 method_9534(class_2680 state, class_1937 world, class_2338 pos, class_1657 player, class_1268 hand, class_3965 hit) {
		class_1799 heldStack = player.method_6118(hand == class_1268.field_5808 ? class_1304.field_6173 : class_1304.field_6171);

		if(heldStack.method_7960()) {
			return class_1269.field_5814;
		}

		class_1792 held = heldStack.method_7909();
		if(!(held instanceof class_1766)) {
			return class_1269.field_5814;
		}

		class_1766 tool = (class_1766) held;

		if(hit.method_17780() == class_2350.field_11033 || !world.method_8320(pos.method_10084()).method_11588()) {
			return class_1269.field_5814;
		}

		if(path != null && (tool.method_7856(state) || tool.method_7865(heldStack, state) > 1.0F || tool instanceof class_1821)) {
			world.method_8396(player, pos, class_3417.field_14616, class_3419.field_15245, 1.0F, 1.0F);

			if(!world.field_9236) {
				world.method_8501(pos, path.get().method_9564());

				heldStack.method_7956(1, player, consumedPlayer -> consumedPlayer.method_20236(hand));
			}

			return class_1269.field_5812;
		}

		return class_1269.field_5814;
	}
}
