package com.terraformersmc.terraform.surface;

import com.mojang.datafixers.Dynamic;
import java.util.Random;
import java.util.function.DoubleFunction;
import java.util.function.Function;
import net.minecraft.class_1959;
import net.minecraft.class_2246;
import net.minecraft.class_2338;
import net.minecraft.class_2680;
import net.minecraft.class_2791;
import net.minecraft.class_3523;
import net.minecraft.class_3527;

public class BeachSurfaceBuilder extends class_3523<class_3527> {
	protected int seaLevel;
	private DoubleFunction<class_2680> sand;

	protected final class_2680 WATER = class_2246.field_10382.method_9564();

	public BeachSurfaceBuilder(Function<Dynamic<?>, ? extends class_3527> function, int seaLevel, DoubleFunction<class_2680> sand)
	{
		super(function);

		this.seaLevel = seaLevel;
		this.sand = sand;
	}

	@Override
	public void generate(Random rand, class_2791 chunk, class_1959 biome, int x, int z, int height, double noiseVal, class_2680 var9, class_2680 var10, int var11, long seed, class_3527 config)
	{
		int localX = x & 15;
		int localZ = z & 15;

		class_2680 chosenSand = sand.apply(noiseVal);
		int thickness = (int)(noiseVal / 3.0D + 3.0D + rand.nextDouble() * 0.25D);

		int run = 0;
		boolean beach = false;
		boolean underwater = false;

		class_2338.class_2339 pos = new class_2338.class_2339(localX, 0, localZ);

		for (int y = height; y >= 0; --y)
		{
			pos.method_10103(localX, y, localZ);
			class_2680 chunkBlock = chunk.method_8320(pos);

			if (chunkBlock == field_15706 && y < 255) {
				class_2680 toSet = field_15706;

				if (chunk.method_8320(pos.method_10084()).method_11588()) {
					beach = y < seaLevel + 3;
					toSet = beach ? chosenSand : config.method_15337();
				} else if (chunk.method_8320(pos.method_10084()) == WATER || run < thickness && underwater) {
					underwater = true;

					if(y > seaLevel - 3) {
						beach = true;
						toSet = chosenSand;
					} else {
						toSet = config.method_15330();
					}
				} else if (y > seaLevel - 3) {
					if(beach) {
						toSet = chosenSand;
					} else if(run < thickness) {
						toSet = config.method_15336();
					}
				}

				chunk.method_12010(pos, toSet, false);
				run++;

			} else {
				run = 0;
				beach = false;
				underwater = false;
			}
		}
	}
}
